--AH:ScriptId=2dd1da3f-364b-4f3b-be36-dd6251e99cf8;218
CREATE TABLE [ReleaseNotes] (

	[Application_Id] INT NOT NULL,
	CONSTRAINT [FK__ReleaseNotes__Applications] 
	FOREIGN KEY ([Application_Id]) REFERENCES [Applications]([Application_Id]),

	[Release_Number] RELEASENUMBER NOT NULL,
	CONSTRAINT [FK__ReleaseNotes__Releases] 
	FOREIGN KEY ([Application_Id],[Release_Number]) REFERENCES [Releases]([Application_Id],[Release_Number]),

	[ReleaseNote_Sequence] INT NOT NULL,
	CONSTRAINT [PK__ReleaseNotes] PRIMARY KEY ([Application_Id],[Release_Number],[ReleaseNote_Sequence]),

	[Build_Number] BUILDNUMBER NULL,
	CONSTRAINT [FK__Release_Notes__Builds]
	FOREIGN KEY ([Application_Id],[Release_Number],[Build_Number]) REFERENCES [Builds]([Application_Id],[Release_Number],[Build_Number]),

	[Environment_Id] INT NULL
	CONSTRAINT [FK__ReleaseNotes__Environments]
	FOREIGN KEY ([Environment_Id]) REFERENCES [Environments]([Environment_Id]),

	CONSTRAINT [CK__ReleaseNotes__References]
	CHECK (    ([Build_Number] IS NULL AND [Environment_Id] IS NULL)
           OR  ([Build_Number] IS NOT NULL AND [Environment_Id] IS NULL)
           OR  ([Build_Number] IS NOT NULL AND [Environment_Id] IS NOT NULL)
          ),

	[Notes_Text] VARCHAR(MAX),

	[CreatedBy_User_Name] USERNAME NOT NULL,
	[CreatedOn_Date] DATETIME NOT NULL,
	[ModifiedBy_User_Name] USERNAME NOT NULL,
	[ModifiedOn_Date] [datetime] NOT NULL,

)

-- drop table releasenotes