--AH:ScriptId=36bc49b8-ae65-49aa-8ac5-58d60075edab;634

ALTER TABLE [Workflows]
  ADD [AllowOutOfSequencePromotions_Indicator] YNINDICATOR NULL,
      [AutoCancelReleases_Indicator] YNINDICATOR NULL,
      [AutoIncrementRelease_Indicator] YNINDICATOR NULL
GO

UPDATE [Workflows]
 SET [AllowOutOfSequencePromotions_Indicator] = 'N',
     [AutoCancelReleases_Indicator] = 'Y',
     [AutoIncrementRelease_Indicator] = (SELECT COALESCE(A.[AutoIncrementRelease_Indicator], 'Y')
                                           FROM [Applications] A
                                          WHERE A.[Application_Id] = W.[Application_Id])
FROM [Workflows] W
GO

ALTER TABLE [Workflows]
  ALTER COLUMN [AllowOutOfSequencePromotions_Indicator] YNINDICATOR NOT NULL
GO
ALTER TABLE [Workflows]
  ALTER COLUMN [AutoCancelReleases_Indicator] YNINDICATOR NOT NULL
GO
ALTER TABLE [Workflows]
  ALTER COLUMN [AutoIncrementRelease_Indicator] YNINDICATOR NOT NULL
GO

-- remove anonymous DEFAULT constraint on [AutoIncrementRelease_Indicator]
DECLARE @ConstraintName NVARCHAR(200)
    SELECT @ConstraintName = Name
      FROM SYS.DEFAULT_CONSTRAINTS 
     WHERE PARENT_OBJECT_ID = OBJECT_ID('Applications') 
       AND PARENT_COLUMN_ID = (SELECT column_id 
                                 FROM sys.columns 
                                WHERE NAME = 'AutoIncrementRelease_Indicator' 
                                  AND object_id = OBJECT_ID('Applications'))
IF @ConstraintName IS NOT NULL
    EXEC('ALTER TABLE [Applications] DROP CONSTRAINT ' + @ConstraintName)
GO

-- remove anonymous DEFAULT constraint on [ApplicationPriority_Number]
DECLARE @ConstraintName NVARCHAR(200)
    SELECT @ConstraintName = Name
      FROM SYS.DEFAULT_CONSTRAINTS 
     WHERE PARENT_OBJECT_ID = OBJECT_ID('Applications') 
       AND PARENT_COLUMN_ID = (SELECT column_id 
                                 FROM sys.columns 
                                WHERE NAME = 'ApplicationPriority_Number' 
                                  AND object_id = OBJECT_ID('Applications'))
IF @ConstraintName IS NOT NULL
    EXEC('ALTER TABLE [Applications] DROP CONSTRAINT ' + @ConstraintName)
GO

ALTER TABLE [Applications]
  DROP COLUMN [AutoIncrementRelease_Indicator]
GO

ALTER TABLE [Applications]
  DROP COLUMN [ApplicationPriority_Number]
GO