--AH:ScriptId=0358ec17-292f-409c-9750-dffef19bfc10;2804
DECLARE @InstanceGaps TABLE
(
	[ConfigurationFile_Id] INT NOT NULL,
	[Instance_Name] VARCHAR(100) NOT NULL,
	[Version_Number] INT NOT NULL,
	[Count] INT NOT NULL
)

INSERT INTO @InstanceGaps
(
	[ConfigurationFile_Id],
	[Instance_Name],
	[Version_Number],
	[Count]
)
SELECT CFV.[ConfigurationFile_Id],
	   CFV.[Instance_Name],
	   [Version_Number] = MAX([Version_Number]),
	   [Count] = MAX(CFV_Max.[Max_Version_Number]) - MAX([Version_Number])
  FROM [ConfigurationFileVersions] CFV
       INNER JOIN (SELECT [ConfigurationFile_Id],
                          [Max_Version_Number] = MAX([Version_Number])
                     FROM [ConfigurationFileVersions]
                    GROUP BY [ConfigurationFile_Id]) CFV_Max
		       ON CFV_Max.[ConfigurationFile_Id] = CFV.[ConfigurationFile_Id]
 GROUP BY CFV.[ConfigurationFile_Id], CFV.[Instance_Name]
HAVING MAX(CFV.[Version_Number]) < MAX(CFV_Max.[Max_Version_Number])

INSERT INTO [ConfigurationFileVersions]
(
	[ConfigurationFile_Id],
	[Instance_Name],
	[Version_Number],
	[VersionNotes_Text],
	[File_Date],
	[File_Bytes],
	[CreatedBy_User_Name],
	[CreatedOn_Date]
)
SELECT CFV.[ConfigurationFile_Id],
       CFV.[Instance_Name],
	   CFV.[Version_Number] + N.[Number],
	   NULL,
	   NULL,
	   NULL,
	   NULL,
	   NULL
  FROM @InstanceGaps IG
       INNER JOIN [Numbers] N
	           ON N.[Number] >= 1 AND N.[Number] <= IG.[Count]
	   INNER JOIN [ConfigurationFileVersions] CFV
	           ON CFV.[ConfigurationFile_Id] = IG.[ConfigurationFile_Id]
			  AND CFV.[Instance_Name] = IG.[Instance_Name]
			  AND CFV.[Version_Number] = IG.[Version_Number]
