--AH:ScriptId=ab3f418d-f131-44ed-b2e2-06e357007d25;3017
EXEC sp_rename 'BUILDNUMBER', 'BUILDNUMBER_X', 'USERDATATYPE';
EXEC sp_rename 'RELEASENUMBER', 'RELEASENUMBER_X', 'USERDATATYPE';
GO

CREATE TYPE [BUILDNUMBER] FROM VARCHAR(50) NULL
CREATE TYPE [RELEASENUMBER] FROM VARCHAR(50) NULL
GO

ALTER TABLE [Builds]
  ALTER COLUMN [Build_Number] BUILDNUMBER NOT NULL

ALTER TABLE [Releases]
  ALTER COLUMN [Release_Number] RELEASENUMBER NOT NULL
GO
ALTER TABLE [Releases]
  ALTER COLUMN [Furthest_Build_Number] BUILDNUMBER NULL
GO
ALTER TABLE [Issues]
  ALTER COLUMN [OpenedOn_Original_Build_Number] BUILDNUMBER NULL
GO
ALTER TABLE [Issues]
  ALTER COLUMN [ClosedOn_Original_Build_Number] BUILDNUMBER NULL
GO


-- refresh all stored procedures and views that reference the types in order to drop the types

DECLARE @ObjectNames TABLE ([Id] INT IDENTITY(1,1), [Name] SYSNAME)

INSERT INTO @ObjectNames ([Name])
     SELECT DISTINCT '[' + s.[name] + '].[' + sp.[name] + ']' 
       FROM sys.procedures sp
      INNER JOIN sys.schemas s ON s.schema_id = sp.schema_id
      INNER JOIN sys.parameters p ON sp.object_id = p.object_id
      INNER JOIN sys.types t ON t.user_type_id = p.user_type_id
      WHERE sp.is_ms_shipped = 0
        AND t.name IN ('BUILDNUMBER_X', 'RELEASENUMBER_X')

INSERT INTO @ObjectNames ([Name])
     SELECT DISTINCT '[' + s.[name] + '].[' + o.[name] + ']'
       FROM sys.objects o
      INNER JOIN sys.schemas s ON s.schema_id = o.schema_id
      INNER JOIN sys.columns c ON c.object_id = o.object_id
      INNER JOIN sys.types t ON t.user_type_id = c.user_type_id
      WHERE o.is_ms_shipped = 0
        AND o.type IN ('V', 'TF') -- view, table-valued function
        AND t.name IN ('BUILDNUMBER_X', 'RELEASENUMBER_X')

DECLARE @Id INT
DECLARE @Name SYSNAME

WHILE EXISTS(SELECT * FROM @ObjectNames)
BEGIN
    
    SELECT TOP 1 @Id = [Id], 
                 @Name = [Name]
      FROM @ObjectNames

    BEGIN TRY
        EXEC sp_refreshsqlmodule @Name
    END TRY
    BEGIN CATCH
        PRINT 'Error recompiling object: ' + @Name + ' - ' + ERROR_MESSAGE()
    END CATCH

    DELETE @ObjectNames WHERE [Id] = @Id

END

BEGIN TRY
    DROP TYPE [BUILDNUMBER_X]
END TRY
BEGIN CATCH
    PRINT 'Error dropping BUILDNUMBER_X: ' + ERROR_MESSAGE()
END CATCH

BEGIN TRY
    DROP TYPE [RELEASENUMBER_X]
END TRY
BEGIN CATCH
    PRINT 'Error dropping RELEASENUMBER_X: ' + ERROR_MESSAGE()
END CATCH