EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Events_RaiseEvent',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ NULL,
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Stored procedure for internal use only.'
GO

IF OBJECT_ID('[Events_RaiseEvent]') IS NOT NULL
	DROP PROCEDURE [Events_RaiseEvent]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Events_RaiseEvent]
(
	@Event_Code VARCHAR(8),
	@Application_Id INT = NULL,
	@detail1 SQL_VARIANT = NULL,
	@detail2 SQL_VARIANT = NULL,
	@detail3 SQL_VARIANT = NULL,
	@detail4 SQL_VARIANT = NULL,
	@detail5 SQL_VARIANT = NULL
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	DECLARE @User_Name USERNAME
		SET @User_Name = COALESCE(dbo.Session_GetUserName(), 'SYSTEM')

	INSERT INTO [EventOccurences]
	 ([Event_Code],[User_Name],[Occurence_Date],[Application_Id])
	 VALUES
	 (@Event_Code, @User_Name, GETUTCDATE(), @Application_Id)

	DECLARE @EventOccurence_Id INT
		SET @EventOccurence_Id = SCOPE_IDENTITY()

	INSERT INTO [EventOccurenceDetails]
	 ([EventOccurence_Id],[Event_Code],[Detail_Name],[Detail_Value])
	SELECT @EventOccurence_Id
		  ,[Event_Code]
		  ,[Detail_Name]
		  ,CASE [Detail_Sequence]
				WHEN 1 THEN @detail1
				WHEN 2 THEN @detail2
				WHEN 3 THEN @detail3
				WHEN 4 THEN @detail4
				WHEN 5 THEN @detail5
				ELSE NULL END
	  FROM [EventTypeDetails]
	 WHERE [Event_Code] = @Event_Code

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Events_RaiseEvent] TO [BuildMasterUser_Role]
