EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Artifacts_ImportArtifact',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Imports build artifact information.'
GO

IF OBJECT_ID('[Artifacts_ImportArtifact]') IS NOT NULL DROP PROCEDURE [Artifacts_ImportArtifact]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Artifacts_ImportArtifact]
(
	@Build_Id INT,
	@Artifact_Name VARCHAR(50),
	@Created_Date DATETIME,
	@Deployable_Id INT,
	@Artifact_Path VARCHAR(250),
	@Execution_Id INT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	INSERT INTO [BuildArtifacts]
	(
		[Deployable_Id],
		[Artifact_Name],
		[Execution_Id],
		[Created_Date],
		[Build_Id],
		[Artifact_Path]
	)
	VALUES
	(
		@Deployable_Id,
		@Artifact_Name,
		@Execution_Id,
		@Created_Date,
		@Build_Id,
		@Artifact_Path
	)

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Artifacts_ImportArtifact] TO [BuildMasterUser_Role]
