EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Executions_PurgeSystemExecutions',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Purges old system executions (retention policy, build trigger, and general/manual) based on configured settings'
GO

IF OBJECT_ID('[Executions_PurgeSystemExecutions]') IS NOT NULL DROP PROCEDURE Executions_PurgeSystemExecutions
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Executions_PurgeSystemExecutions]
(
	@KeepLastSystemExecutionCount INT = 1000
) AS
BEGIN

	SET NOCOUNT ON

	DELETE [Executions]
	FROM [Executions] E,
	(
		SELECT [Execution_Id], ROW_NUMBER() OVER(PARTITION BY [ExecutionMode_Code] ORDER BY [Execution_Id] DESC) [Row]
		FROM [Executions]
		WHERE [ExecutionMode_Code] IN ('R', 'M', 'T')
	) EE
	WHERE E.[Execution_Id] = EE.[Execution_Id] AND EE.[Row] > @KeepLastSystemExecutionCount
	
END
GO

GRANT EXECUTE ON [Executions_PurgeSystemExecutions] TO [BuildMasterUser_Role]
