EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'SecureResources_GetSecureResourceByName',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataRow',
    /* DataTableNames_Csv      */ 'SecureResources',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Finds the specified secure resource by name and application.'
GO


IF OBJECT_ID('[SecureResources_GetSecureResourceByName]') IS NOT NULL DROP PROCEDURE [SecureResources_GetSecureResourceByName]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [SecureResources_GetSecureResourceByName]
(
    @SecureResource_Name VARCHAR(50),
	@Application_Id INT = NULL
)
AS
BEGIN

	SET NOCOUNT ON

    SELECT * 
      FROM [SecureResources]
     WHERE [SecureResource_Name] = @SecureResource_Name
       AND ((@Application_Id IS NULL AND [Application_Id] IS NULL) OR [Application_Id] = @Application_Id)
END
GO

GRANT EXECUTE ON [SecureResources_GetSecureResourceByName] TO [BuildMasterUser_Role]