EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Variables_GetVariablesForScope',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Variables',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the variables that are defined only in the specified scope.'
GO


IF OBJECT_ID('[Variables_GetVariablesForScope]') IS NOT NULL DROP PROCEDURE [Variables_GetVariablesForScope]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Variables_GetVariablesForScope]
(
	@Environment_Id INT = NULL,
    @ServerRole_Id INT = NULL,
    @Server_Id INT = NULL,
    @ApplicationGroup_Id INT = NULL,
    @Application_Id INT = NULL,
    @Deployable_Id INT = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT *
	  FROM [Variables]
	 WHERE ([Environment_Id] = @Environment_Id OR ([Environment_Id] IS NULL AND @Environment_Id IS NULL))
	   AND ([ServerRole_Id] = @ServerRole_Id OR ([ServerRole_Id] IS NULL AND @ServerRole_Id IS NULL))
       AND ([Server_Id] = @Server_Id OR ([Server_Id] IS NULL AND @Server_Id IS NULL))
       AND ([ApplicationGroup_Id] = @ApplicationGroup_Id OR ([ApplicationGroup_Id] IS NULL AND @ApplicationGroup_Id IS NULL))
       AND ([Application_Id] = @Application_Id OR ([Application_Id] IS NULL AND @Application_Id IS NULL))
       AND ([Deployable_Id] = @Deployable_Id OR ([Deployable_Id] IS NULL AND @Deployable_Id IS NULL))

END
GO

GRANT EXECUTE ON [Variables_GetVariablesForScope] TO [BuildMasterUser_Role]